package models

import (
	"time"

	"github.com/beego/beego/v2/client/orm"
)

type ReportPdf struct {
	ReportPdfId        int       `orm:"pk" description:"id"`
	PdfUrl             string    `description:"pdf文件URL"`
	Title              string    `description:"pdf文件标题"`
	Author             string    `description:"作者"`
	Abstract           string    `description:"摘要"`
	ClassifyIdFirst    int       `description:"一级分类id"`
	ClassifyNameFirst  string    `description:"一级分类名称"`
	ClassifyIdSecond   int       `description:"二级分类id"`
	ClassifyNameSecond string    `description:"二级分类名称"`
	Stage              int       `description:"期数"`
	PublishTime        time.Time `description:"发布时间"`
	ModifyTime         time.Time `description:"更新时间"`
	Pv                 int       `description:"pv"`
	Uv                 int       `description:"uv"`
	SysUserId          int       `description:"创建人id"`
	SysRealName        string    `description:"创建人姓名"`
	State              int       `description:"状态"`
}

func (r *ReportPdf) Add() (err error) {
	o := orm.NewOrm()
	// 计算研报期数
	sql := `SELECT COUNT(*) + 1 AS count FROM report_pdf WHERE classify_id_second=?`
	err = o.Raw(sql, r.ClassifyIdSecond).QueryRow(&r.State)
	if err != nil {
		return
	}
	_, err = o.Insert(r)
	return
}

func GetReportPdfCountByCondition(condition string, pars []interface{}) (count int, err error) {
	o := orm.NewOrm()
	sql := `SELECT COUNT(*) AS count FROM report_pdf WHERE 1=1 `
	if condition != "" {
		sql += condition
	}
	err = o.Raw(sql, pars).QueryRow(&count)
	return
}

func GetReportPdfByCondition(condition, sortCondition string, pars []interface{}, startPage, pageSize int) (items []*ReportPdf, err error) {
	o := orm.NewOrm()
	sql := `SELECT * FROM report_pdf WHERE 1=1 `
	if condition != "" {
		sql += condition
	}
	if sortCondition != "" {
		sql += sortCondition // 排序
	}
	sql += ` LIMIT ?,?`
	_, err = o.Raw(sql, pars, startPage, pageSize).QueryRows(&items)
	return
}
